package io.dekorate.kubernetes.config;

import java.lang.StringBuffer;
import java.lang.StringBuilder;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;

public class KubernetesConfigFluentImpl<A extends KubernetesConfigFluent<A>> extends BaseConfigFluentImpl<A> implements KubernetesConfigFluent<A>{

    private String dockerFile = "Dockerfile";
    private String registry = "";
    private boolean autoPushEnabled = false;
    private boolean autoBuildEnabled = false;

    public KubernetesConfigFluentImpl(){
    }
    public KubernetesConfigFluentImpl(KubernetesConfig instance){
            this.withProject(instance.getProject()); 
            this.withAttributes(instance.getAttributes()); 
            this.withGroup(instance.getGroup()); 
            this.withName(instance.getName()); 
            this.withVersion(instance.getVersion()); 
            this.withInitContainers(instance.getInitContainers()); 
            this.withLabels(instance.getLabels()); 
            this.withAnnotations(instance.getAnnotations()); 
            this.withEnvVars(instance.getEnvVars()); 
            this.withWorkingDir(instance.getWorkingDir()); 
            this.withCommand(instance.getCommand()); 
            this.withArguments(instance.getArguments()); 
            this.withReplicas(instance.getReplicas()); 
            this.withServiceAccount(instance.getServiceAccount()); 
            this.withHost(instance.getHost()); 
            this.withPorts(instance.getPorts()); 
            this.withServiceType(instance.getServiceType()); 
            this.withPvcVolumes(instance.getPvcVolumes()); 
            this.withSecretVolumes(instance.getSecretVolumes()); 
            this.withConfigMapVolumes(instance.getConfigMapVolumes()); 
            this.withGitRepoVolumes(instance.getGitRepoVolumes()); 
            this.withAwsElasticBlockStoreVolumes(instance.getAwsElasticBlockStoreVolumes()); 
            this.withAzureDiskVolumes(instance.getAzureDiskVolumes()); 
            this.withAzureFileVolumes(instance.getAzureFileVolumes()); 
            this.withMounts(instance.getMounts()); 
            this.withImagePullPolicy(instance.getImagePullPolicy()); 
            this.withLivenessProbe(instance.getLivenessProbe()); 
            this.withReadinessProbe(instance.getReadinessProbe()); 
            this.withSidecars(instance.getSidecars()); 
            this.withExpose(instance.isExpose()); 
            this.withAutoDeployEnabled(instance.isAutoDeployEnabled()); 
            this.withDockerFile(instance.getDockerFile()); 
            this.withRegistry(instance.getRegistry()); 
            this.withAutoPushEnabled(instance.isAutoPushEnabled()); 
            this.withAutoBuildEnabled(instance.isAutoBuildEnabled()); 
    }

    public String getDockerFile(){
            return this.dockerFile;
    }

    public A withDockerFile(String dockerFile){
            this.dockerFile=dockerFile; return (A) this;
    }

    public Boolean hasDockerFile(){
            return this.dockerFile != null;
    }

    public A withNewDockerFile(String arg1){
            return (A)withDockerFile(new String(arg1));
    }

    public A withNewDockerFile(StringBuilder arg1){
            return (A)withDockerFile(new String(arg1));
    }

    public A withNewDockerFile(StringBuffer arg1){
            return (A)withDockerFile(new String(arg1));
    }

    public String getRegistry(){
            return this.registry;
    }

    public A withRegistry(String registry){
            this.registry=registry; return (A) this;
    }

    public Boolean hasRegistry(){
            return this.registry != null;
    }

    public A withNewRegistry(String arg1){
            return (A)withRegistry(new String(arg1));
    }

    public A withNewRegistry(StringBuilder arg1){
            return (A)withRegistry(new String(arg1));
    }

    public A withNewRegistry(StringBuffer arg1){
            return (A)withRegistry(new String(arg1));
    }

    public boolean isAutoPushEnabled(){
            return this.autoPushEnabled;
    }

    public A withAutoPushEnabled(boolean autoPushEnabled){
            this.autoPushEnabled=autoPushEnabled; return (A) this;
    }

    public Boolean hasAutoPushEnabled(){
            return true;
    }

    public boolean isAutoBuildEnabled(){
            return this.autoBuildEnabled;
    }

    public A withAutoBuildEnabled(boolean autoBuildEnabled){
            this.autoBuildEnabled=autoBuildEnabled; return (A) this;
    }

    public Boolean hasAutoBuildEnabled(){
            return true;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            KubernetesConfigFluentImpl that = (KubernetesConfigFluentImpl) o;
            if (dockerFile != null ? !dockerFile.equals(that.dockerFile) :that.dockerFile != null) return false;
            if (registry != null ? !registry.equals(that.registry) :that.registry != null) return false;
            if (autoPushEnabled != that.autoPushEnabled) return false;
            if (autoBuildEnabled != that.autoBuildEnabled) return false;
            return true;
    }




}
